#include "StateMachine.h"
#include "Timing.h"
#include "Logger.h"
#include "render/Text.h"
#include "Graphics.h"
#include "Quirks.h"
#include "map/Map.h"
#include "map/StateMap.h"
#include "undertale_battle/StateUndertaleBattle.h"
#include "utility/misc.h"

using namespace WalrusRPG;
using WalrusRPG::PIAF::Archive;
using WalrusRPG::Graphics::Texture;
using namespace WalrusRPG::Graphics;

int main(int argc, char *argv[])
{
    UNUSED(argc);
    Logger::log("WalrusRPG Init");
    Graphics::init();
    Timing::init();
    Quirks::init(argv[0]);
    Text::init();

    StateMachine::init();
    StateMachine::push(new States::StateUndertaleBattle());
    StateMachine::run();

    Logger::log("WalrusRPG Deinit");
    StateMachine::deinit();
    Quirks::deinit();
    Timing::deinit();
    Graphics::deinit();

    return 0;
}
