#include <cstring>
#include "BattleTextTransition.h"
#include "GraphicsEx.h"
#include "input/Input.h"
#include "utility/misc.h"

#define BATTLETEXT WalrusRPG::Undertale::BattleStates::BattleTextTransition
using namespace WalrusRPG::Graphics;
using namespace WalrusRPG::Input;
using WalrusRPG::Undertale::UndertaleBattleStateMachine;

BATTLETEXT::BattleTextTransition(UndertaleBattleStateMachine &parent,
                                 IdleText &text_to_draw, VBattleState *next_state)
    : VBattleState(parent), text_to_draw(text_to_draw), next_state(next_state),
      text_length(0), ready_to_go_next(false)
{
}

BATTLETEXT::~BattleTextTransition()
{
}

void BATTLETEXT::update(unsigned dt)
{
    UNUSED(dt);
    if (!ready_to_go_next)
    {
        ++text_length;
        unsigned real_text_length = text_length / 2;
        if (real_text_length > strlen(text_to_draw.line1) + strlen(text_to_draw.line2) +
                                   strlen(text_to_draw.line3))
        {
            ready_to_go_next = true;
        }
    }
    else
    {
        if (Input::key_pressed(K_A))
            machine.set_state(next_state);
    }
}

void BATTLETEXT::render(unsigned dt)
{
    UNUSED(dt);
    fill(Graphics::Black);
    draw_frame();

    draw_enemies(machine.get_enemies(), machine.get_nb_enemies());
    draw_hud(machine.health, machine.health_max);

    draw_text_hitbox(machine.text_box_dimensions, 2);

    put_text(text_to_draw.line1, text_to_draw.line2, text_to_draw.line3, text_length / 2);
}