#ifndef INCLUDE_GRAPHICS_EX
#define INCLUDE_GRAPHICS_EX

#include "Graphics.h"
#include "VEnemy.h"
#include "TINYSTL/string.h"
#include "UndertaleBattleStateMachine.h"

namespace WalrusRPG
{
    namespace Graphics
    {
        void put_char(unsigned char c, unsigned x, unsigned y);
        void put_char(unsigned char c, unsigned x, unsigned y, const Pixel &color);

        // Specific
        void put_bubble_char(unsigned char c, unsigned x, unsigned y, const Pixel &color);
        void put_bubble_char(unsigned char c, unsigned x, unsigned y);
        void put_bubble_string(const tinystl::string &str, unsigned x, unsigned y);
        void put_bubble_string(const tinystl::string &str, unsigned x, unsigned y,
                               const Pixel &color);


        void put_hud_char(unsigned char c, unsigned x, unsigned y, const Pixel &color);
        void put_hud_char(unsigned char c, unsigned x, unsigned y);
        void put_string(const tinystl::string &str, unsigned x, unsigned y);
        void put_string(const tinystl::string &str, unsigned x, unsigned y,
                        const Pixel &color);
        void put_hud_string(const tinystl::string &str, unsigned x, unsigned y);
        void put_hud_string(const tinystl::string &str, unsigned x, unsigned y,
                            const Pixel &color);
        void put_string_clip(const char *str, unsigned x, unsigned y, unsigned max_length,
                     const Pixel &color);
        void put_string_clip(const char *str, unsigned x, unsigned y, unsigned max_length);
        void put_text(const tinystl::string &line1, const tinystl::string &line2,
                      const tinystl::string &line3, unsigned text_index);
        void draw_frame();
        void draw_frame(unsigned fade_in_color);
        void draw_text_hitbox(const WalrusRPG::Utils::Rect &cell, unsigned stroke_width);
        void draw_text_hitbox(const WalrusRPG::Utils::Rect &dim, unsigned stroke_width,
                              unsigned fade_in_color);

        void draw_enemy_damage_missed(signed y_offset,
                                      const WalrusRPG::Utils::Rect &cell);
        void draw_enemy_damage(unsigned damage_done, signed y_offset,
                               const WalrusRPG::Utils::Rect &cell);
        void draw_enemy_life_bar(unsigned hp_max, unsigned hp,
                                 const WalrusRPG::Utils::Rect &cell);
        void draw_enemies(WalrusRPG::Undertale::VEnemy **enemies, unsigned nb_enemies);
        void draw_enemies(WalrusRPG::Undertale::VEnemy **enemies, unsigned nb_enemies,
                          unsigned brightness);

        void draw_menu_buttons(unsigned selected_button);
        void draw_menu_buttons(unsigned selected_button, unsigned brightness);

        void draw_hud(unsigned hp, unsigned hp_max);
        void draw_hud(unsigned hp, unsigned hp_max, unsigned brightness);
    }
}

#endif
