#include "Item.h"
#include "UndertaleBattleStateMachine.h"
#include "BattleTextTransition.h"
#include "BattleMainMenu.h"
#include "VEnemy.h"
#include "utility/misc.h"

#define ITEM WalrusRPG::Undertale::Item

using WalrusRPG::Undertale::Item;
using WalrusRPG::Undertale::IdleText;
using WalrusRPG::Undertale::item_id;
using WalrusRPG::Undertale::UndertaleBattleStateMachine;
using WalrusRPG::Undertale::BattleStates::BattleTextTransition;
using WalrusRPG::Undertale::BattleStates::BattleMainMenu;


IdleText use_text = {"* This isn't real, nor usable.", "...", "* How did you get this?"};

Item::Item(item_id id, char const *name, char const *name_short)
    : id(id), name(name), name_short(name_short)
{
}

Item::~Item()
{
}

const char *Item::get_name()
{
    return name;
}

const char *Item::get_short_name(bool serious)
{
    UNUSED(serious);
    return name_short;
}

item_id Item::get_id()
{
    return id;
}

void Item::use(UndertaleBattleStateMachine &machine)
{
    machine.set_state(
        new BattleTextTransition(machine, use_text, new BattleMainMenu(machine)));
}
