#ifndef INCLUDE_ITEM_H
#define INCLUDE_ITEM_H

#include "UndertaleBattleStateMachine.h"

namespace WalrusRPG
{
    namespace Undertale
    {
        enum item_id
        {
            UNKNOWN,
            STICK,
            MONSTER_CANDY
        };

        class Item
        {
          public:
            Item(item_id id, char const *name, char const *name_short);
            virtual ~Item();
            const char *get_name();
            const char *get_short_name(bool serious);
            item_id get_id();
            virtual void use(UndertaleBattleStateMachine &machine);

          protected:
            item_id id;
            const char *name;
            const char *name_short;
        }; // class Item

        // extern Item items[];
    } /* namespace Undertale */
} /* namespace WalrusRPG */
#endif
