#include "Particle.h"

using WalrusRPG::Undertale::Particle;
using WalrusRPG::Utils::Rect;
using WalrusRPG::Graphics::Pixel;

Particle::Particle(unsigned x, unsigned y, signed dx, signed dy, unsigned size, unsigned life, const WalrusRPG::Graphics::Pixel& col)
	: rect{static_cast<int>(x*8), static_cast<int>(y*8), size, size}, life(life), dx(dx), dy(dy), col(col), alive(true)
{

}

Particle::Particle(const Particle &p)
	: rect(p.rect), life(p.life), dx(p.dx), dy(p.dy), col(p.col), alive(p.alive)
{

}

Particle::~Particle()
{

} 

void Particle::update(unsigned dt)
{
	if(!alive) return;
	rect.x += dx*dt;
	rect.y += dy*dt;
	signed rx = rect.x/8, ry = rect.y/8;
	if(life <= dt)
	{
		alive = false;
	}
	else life -= dt;
}

void Particle::render(unsigned dt)
{
	Rect r{rect.x/8, rect.y/8, rect.width, rect.height};
	Graphics::put_rectangle(r, col);
}