#include "VEnemy.h"

#define VENEMY WalrusRPG::Undertale::VEnemy

using WalrusRPG::Undertale::VEnemyAttack;
using WalrusRPG::Graphics::Texture;
using WalrusRPG::Utils::Rect;

VENEMY::VEnemy(WalrusRPG::Graphics::Texture &tex, char const *name,
               bool show_lifebar_in_menu, UndertaleBattleStateMachine &machine,
               unsigned hp, unsigned att, unsigned def, unsigned cell_x, unsigned cell_y)
    : machine(machine), tex(tex), name(name), show_lifebar_in_menu(show_lifebar_in_menu),
      spareable(false), spared(false), hp(hp), hp_max(hp), att(att), def(def),
      bonus_att(0), bonus_def(0), cell_x(cell_x), cell_y(cell_y), selected_attack(nullptr)

                                                                      {};
VENEMY::~VEnemy()
{
    if (selected_attack != nullptr)
        delete selected_attack;
}

void VENEMY::reset()
{
    hp = hp_max;
    spared = false;
    spareable = false;
}

// state
unsigned VENEMY::get_hp()
{
    return hp;
}
unsigned VENEMY::get_hp_max()
{
    return hp_max;
}
unsigned VENEMY::get_attack()
{
    return att;
}
unsigned VENEMY::get_defense()
{
    return def;
}

bool VENEMY::is_spareable()
{
    return spareable;
};
bool VENEMY::is_spared()
{
    return spared;
};

bool VENEMY::is_dead()
{
    return hp == 0;
}

bool VENEMY::can_attack()
{
    return !is_dead() && !is_spared();
}

bool VENEMY::should_show_lifebar_in_menu()
{
    return show_lifebar_in_menu;
}
const char *VENEMY::get_name()
{
    return name;
};
Texture &VENEMY::get_texture()
{
    return tex;
};
Rect VENEMY::get_cell()
{
    return {cell_x, cell_y};
}

VEnemyAttack *VENEMY::get_selected_attack()
{
    return selected_attack;
}