#ifndef UNDERTALE_VENEMYATTACK_H
#define UNDERTALE_VENEMYATTACK_H

#include <cstdint>
#include "utility/Rect.h"

namespace WalrusRPG
{
    namespace Undertale
    {
        class VEnemyAttack
        {
          protected:
            bool is_combined_attack;

          public:
            VEnemyAttack(bool is_combined_attack);
            virtual ~VEnemyAttack();
            virtual void update(unsigned dt) = 0;
            virtual void render(unsigned dt) = 0;
            virtual uint16_t calculate_damage(uint16_t chara_hp) = 0;
            virtual bool check_collision(WalrusRPG::Utils::Rect &player_hitbox) = 0;
            void set_combined_attack(bool is_combined_attack);
        };
    }
}
#endif