#ifndef UNDERTALE_FROGGITFLYATTACK_H
#define UNDERTALE_FROGGITFLYATTACK_H

#include "VEnemyAttack.h"

namespace WalrusRPG
{
    namespace Undertale
    {
        namespace EnemyAttacks
        {
            class FroggitFlyAttack : public VEnemyAttack
            {
                static constexpr unsigned nb_max_flies = 10;

              private:
                signed flies_x[nb_max_flies];
                signed flies_y[nb_max_flies];
                signed flies_dx[nb_max_flies];
                signed flies_dy[nb_max_flies];
                signed flies_stop_timer[nb_max_flies]; // x, y and dx,dy
                bool flies_stopped[nb_max_flies];      // x, y and dx,dy
                unsigned nb_flies;
                unsigned timer;
                void regen_fly(unsigned index);
                signed heart_x, heart_y;

              public:
                FroggitFlyAttack();
                ~FroggitFlyAttack();
                void update(unsigned dt);
                void render(unsigned dt);
                uint16_t calculate_damage(uint16_t chara_hp);
                bool check_collision(WalrusRPG::Utils::Rect &player_hitbox);
            };
        }
    }
}
#endif