#ifndef INCLUDE_FROGGIT_H
#define INCLUDE_FROGGIT_H
#include "VEnemy.h"
#include "render/Animator.h"
#include "render/SpriteRenderer.h"
#include "utility/Rect.h"
#include "TINYSTL/vector.h"

namespace WalrusRPG
{
    namespace Undertale
    {
        namespace Enemies
        {
            struct Offset
            {
                signed x;
                signed y;
                unsigned duration;
            };
            class Froggit : public VEnemy
            {
              protected:
                unsigned last_player_action;
                unsigned current_line;
                unsigned current_thought;
                unsigned time_spent;
                WalrusRPG::Animator animator;
                WalrusRPG::SpriteRenderer renderer;
                tinystl::vector<Offset> head_offset;
                unsigned total_time;
                unsigned current_time;
                unsigned current_frame;
                bool shaking;
                unsigned shaking_timer;

              public:
                Froggit(UndertaleBattleStateMachine &machine, unsigned cell_x,
                        unsigned cell_y);
                ~Froggit();
                virtual IdleText &get_lines() override;
                virtual const char *get_bubble() override;

                virtual void reset() override;

                virtual void on_act(Act &act) override;
                virtual void on_attack(unsigned damage) override;
                virtual void on_item(Item &item) override;
                virtual void on_spare() override;

                virtual void update(unsigned dt) override;
                virtual void render(WalrusRPG::Utils::Rect &center) override;
                virtual void render(WalrusRPG::Utils::Rect &center,
                                    const WalrusRPG::Graphics::Pixel &tint) override;


                virtual void select_attack() override;

                virtual doable_acts_e *get_doable_acts() override;
            };
        }
    }
}

#endif
