#include "MonsterCandy.h"
#include "BattleTextTransition.h"
#include "BattleEnemyAttack.h"
#include "utility/minmax.h"

using WalrusRPG::Undertale::Items::MonsterCandy;
using WalrusRPG::Undertale::IdleText;
using WalrusRPG::Undertale::UndertaleBattleStateMachine;
using WalrusRPG::Undertale::BattleStates::BattleTextTransition;
using WalrusRPG::Undertale::BattleStates::BattleEnemyAttack;

static IdleText txt = {
    "You eat the candy.", "Mmmh, apple flavour.", "You gain 5HP.",
};

MonsterCandy::MonsterCandy() : Item(MONSTER_CANDY, "Monster Candy", "MnstrCndy")
{
}

MonsterCandy::~MonsterCandy()
{
}

void MonsterCandy::use(UndertaleBattleStateMachine &machine)
{
    machine.set_state(
        new BattleTextTransition(machine, txt, new BattleEnemyAttack(machine)));
    machine.drop_item(this);
    machine.health = min(machine.health + 5, machine.health_max);
}
