#include "Stick.h"
#include "BattleTextTransition.h"
#include "BattleEnemyAttack.h"

using WalrusRPG::Undertale::Items::Stick;
using WalrusRPG::Undertale::IdleText;
using WalrusRPG::Undertale::UndertaleBattleStateMachine;
using WalrusRPG::Undertale::BattleStates::BattleTextTransition;
using WalrusRPG::Undertale::BattleStates::BattleEnemyAttack;

static IdleText txt = {
    "You throw the stick...", "Nothing happens...", "You fetch it yourself.",
};

Stick::Stick() : Item(STICK, "Stick", "Stick")
{
}

Stick::~Stick()
{
}

void Stick::use(UndertaleBattleStateMachine &machine)
{
    machine.set_state(
        new BattleTextTransition(machine, txt, new BattleEnemyAttack(machine)));
}
